Ruby master - Feature #8042

Add Addrinfo#socket to create a socket that is not connected or bound
03/08/2013 08:35 AM - drbrain (Eric Hodel)

Status: Assigned

Priority: Normal

Assignee: matz (Yukihiro Matsumoto)
Target version:

Description

This adds a socket method to Addrinfo to get a socket that has not been bound or connected to any address for connectionless
operation.

History

#1 - 03/08/2013 04:59 PM - akr (Akira Tanaka)
2013/3/8 drbrain (Eric Hodel) drbrain@segment7.net:

Feature #8042: Add Addrinfo#socket to create a socket that is not connected or bound
https://bugs.ruby-lang.org/issues/8042

This adds a socket method to Addrinfo to get a socket that has not been bound or connected to any address for connectionless operation.

| think the method name, Addrinfo#socket, is too generic.

| feel that Addrinfo#socket method uses socket address in Addrinfo object,
but this proposal doesn't.

Tanaka Akira

#2 - 03/11/2013 10:32 AM - drbrain (Eric Hodel)

How about unbound_socket?

I would like to use a feature like this one in rinda/ring.rb for multicast support since options need to be set before connect/bind (see #8073)
Perhaps #connect_to or #bind could take a block that would yield the socket for setsockopt before bind/connect?

#3 - 03/11/2013 11:23 AM - akr (Akira Tanaka)
2013/3/11 drbrain (Eric Hodel) drbrain@segment?.net:

How about unbound_socket?

| like unbound_socket.

Perhaps #connect_to or #bind could take a block that would yield the socket for setsockopt before bind/connect?

It conflicts with current block usage of Addrinfo#connect_to and Addrinfo#bind.

Tanaka Akira

#4 - 03/12/2013 02:18 AM - drbrain (Eric Hodel)
- File addrinfo.socket.2.patch added

Here is an updated patch using #unbound_socket, may | commit?

PS: ext/socket has no listed maintainer, should it be you, Akira-san?

#5 - 03/12/2013 08:53 AM - akr (Akira Tanaka)
2013/3/12 drbrain (Eric Hodel) drbrain@segment7.net:

PS: ext/socket has no listed maintainer, should it be you, Akira-san?
When | want to change API, | tried to obtain approval by matz.
Tanaka Akira
#6 - 06/02/2013 03:32 PM - zzak (Zachary Scott)

- Status changed from Open to Assigned

- Assignee set to drbrain (Eric Hodel)

#7 - 06/12/2013 08:56 AM - drbrain (Eric Hodel)

- Assignee changed from drbrain (Eric Hodel) to matz (Yukihiro Matsumoto)

matz, | need your approval to add Addrinfo#unbound_socket which creates a connectionless socket that allows you to set further socket options

before connect or to use in a connectionless manner.

#8 - 06/24/2013 02:53 AM - headius (Charles Nutter)
Objection: why would an "info" object be able to create a socket?
Wouldn't Socket.unbound_socket(addrinfo) make more sense?

#9 - 06/25/2013 05:59 PM - akr (Akira Tanaka)
2013/6/24 headius (Charles Nutter) headius@headius.com:

Objection: why would an "info" object be able to create a socket?

| think it is natural because object oriented.

Tanaka Akira

#10 - 06/26/2013 02:53 AM - headius (Charles Nutter)

On Tue, Jun 25, 2013 at 3:56 AM, Tanaka Akira akr@fsij.org wrote:

2013/6/24 headius (Charles Nutter) headius@headius.com:

Objection: why would an "info" object be able to create a socket?

| think it is natural because object oriented.

If the object's type were "Address" | might agree. But it's
"AddriInfo"...information about an address. | don't see the OOness of
an informational object being able to do this sort of thing.

I'm bikeshedding of course, but passing address info to a Socket
constructor seems far more OO to me than an address info creating a
socket on its own. Socket should be responsible for creating Socket
instances.

e Charlie

#11 - 10/01/2013 05:46 PM - naruse (Yui NARUSE)

- Target version changed from 2.1.0 to 2.6

#12 - 12/25/2017 06:15 PM - naruse (Yui NARUSE)
- Target version deleted (2.6)

Files
addrinfo.socket.patch 2.54 KB 03/08/2013 drbrain (Eric Hodel)
addrinfo.socket.2.patch 2.6 KB 03/12/2013 drbrain (Eric Hodel)
